//+------------------------------------------------------------------+
//|                                  Test_Wrong_TakeProfit_LEVEL.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property description "      TakeProfit"
#include <Trade\Trade.mqh> 
//--- input parameters
input int      shift=5;    //    TP 
input double   lot=1;      //  
//---
CTrade trade;
//---      ask, bid
double sym_spread,sym_point,buy_price,sell_price;
//---      -      
int d_spread,sym_digits;
//---  SYMBOL_TRADE_STOPS_LEVEL  SYMBOL_TRADE_FREEZE_LEVEL
int freeze_level,stops_level;
//---   
bool buy_done;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   Print(__FILE__);
//---    
   buy_done=false;
//---         
   sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
   PrintFormat("Point=%.5f Digits=%d",sym_point,sym_digits);
//---    
   ENUM_SYMBOL_TRADE_EXECUTION execution_mode=(ENUM_SYMBOL_TRADE_EXECUTION)
                                              SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE);
   PrintFormat("SYMBOL_TRADE_EXECUTION=%s",EnumToString(execution_mode));
//---    ,        
   freeze_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_FREEZE_LEVEL);
   if(freeze_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_FREEZE_LEVEL=%d:     ,"+
                  "   %d    ",freeze_level,freeze_level);
     }
//---     StopLoss  Takeprofit
   stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
   if(stops_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_STOPS_LEVEL=%d: StopLoss  TakeProfit  "+
                  "   %d    ",stops_level,stops_level);
     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   BUY  ,     
   if(buy_done)
      return;
//---  30  ,      TP  1   
   for(int i=1;i<30;i++)
     {
      //---        
      UpdatePricesByTick();
      //---   TakeProfit    Bid (TakeProfit   BUY    )
      double tp=NormalizeDouble(sell_price+(i+stops_level-shift)*sym_point,sym_digits);
      //---    TakeProfit   Bid (  )
      int delta=(int)MathRound((tp-sell_price)/sym_point);
      //---  
      string msg=StringFormat("%d. Buy %.1f %s at %.5f TP=%.5f Bid=%.5f ( TakeProfit-Bid=%d points)",
                              i,lot,_Symbol,buy_price,tp,sell_price,delta);
      //---        
      Print(msg);
      //---   BUY  
      if(trade.Buy(lot,_Symbol,buy_price,0,tp,StringFormat("%d",i)))
        {
         //---  ,     TakeProfit
         int profit=(int)MathRound((tp-buy_price)/sym_point);
         //---
         PrintFormat("Buy %.1f %s done at %.5f with TakeProfit=%d points (SYMBOL_TRADE_STOPS_LEVEL=%d - spread=%d)",
                     lot,_Symbol,buy_price,profit,stops_level,d_spread);
         //---     "  "
         buy_done=true;
         //---       BUY
         break;
        }
      //---   ,    100 ms    
      Sleep(1000);
     }
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
void UpdatePricesByTick()
  {
//---   
   MqlTick tick;
   SymbolInfoTick(_Symbol,tick);
//---       
   buy_price=tick.ask;
   sell_price=tick.bid;
//---      
   sym_spread=tick.ask-tick.bid;
//---     (digital)
   d_spread=(int)MathCeil(sym_spread/sym_point);
//---   
  }
//+------------------------------------------------------------------+
